CatalogSource [operators.coreos.com/v1alpha1]

Description
CatalogSource is a repository of CSVs, CRDs, and operator packages.
Type
object
Required
metadataspec

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject
statusobject

.spec

Type
object
Required
sourceType
PropertyTypeDescription
addressstring

Address is a host that OLM can use to connect to a pre-existing registry. Format: : Only used when SourceType = SourceTypeGrpc. Ignored when the Image field is set.

configMapstring

ConfigMap is the name of the ConfigMap to be used to back a configmap-server registry. Only used when SourceType = SourceTypeConfigmap or SourceTypeInternal.

descriptionstring
displayNamestring

Metadata

grpcPodConfigobject

GrpcPodConfig exposes different overrides for the pod spec of the CatalogSource Pod. Only used when SourceType = SourceTypeGrpc and Image is set.

iconobject
imagestring

Image is an operator-registry container image to instantiate a registry-server with. Only used when SourceType = SourceTypeGrpc. If present, the address field is ignored.

priorityinteger

Priority field assigns a weight to the catalog source to prioritize them so that it can be consumed by the dependency resolver. Usage: Higher weight indicates that this catalog source is preferred over lower weighted catalog sources during dependency resolution. The range of the priority value can go from positive to negative in the range of int32. The default value to a catalog source with unassigned priority would be 0. The catalog source with the same priority values will be ranked lexicographically based on its name.

publisherstring
secretsarray

Secrets represent set of secrets that can be used to access the contents of the catalog. It is best to keep this list small, since each will need to be tried for every catalog entry.

sourceTypestring

SourceType is the type of source

updateStrategyobject

UpdateStrategy defines how updated catalog source images can be discovered Consists of an interval that defines polling duration and an embedded strategy type

.spec.grpcPodConfig

Description
GrpcPodConfig exposes different overrides for the pod spec of the CatalogSource Pod. Only used when SourceType = SourceTypeGrpc and Image is set.
Type
object
PropertyTypeDescription
nodeSelectorobject

NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node.

priorityClassNamestring

If specified, indicates the pod's priority. If not specified, the pod priority will be default or zero if there is no default.

tolerationsarray

Tolerations are the catalog source's pod's tolerations.

.spec.grpcPodConfig.nodeSelector

Description
NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node.
Type
object

.spec.grpcPodConfig.tolerations

Description
Tolerations are the catalog source's pod's tolerations.
Type
array

.spec.grpcPodConfig.tolerations[]

Description
The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
Type
object
PropertyTypeDescription
effectstring

Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.

keystring

Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.

operatorstring

Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

tolerationSecondsinteger

TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.

valuestring

Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.

.spec.icon

Type
object
Required
base64datamediatype
PropertyTypeDescription
base64datastring
mediatypestring

.spec.secrets

Description
Secrets represent set of secrets that can be used to access the contents of the catalog. It is best to keep this list small, since each will need to be tried for every catalog entry.
Type
array

.spec.secrets[]

Type
string

.spec.updateStrategy

Description
UpdateStrategy defines how updated catalog source images can be discovered Consists of an interval that defines polling duration and an embedded strategy type
Type
object
PropertyTypeDescription
registryPollobject

.spec.updateStrategy.registryPoll

Type
object
PropertyTypeDescription
intervalstring

Interval is used to determine the time interval between checks of the latest catalog source version. The catalog operator polls to see if a new version of the catalog source is available. If available, the latest image is pulled and gRPC traffic is directed to the latest catalog source.

.status

Type
object
PropertyTypeDescription
conditionsarray

Represents the state of a CatalogSource. Note that Message and Reason represent the original status information, which may be migrated to be conditions based in the future. Any new features introduced will use conditions.

configMapReferenceobject
connectionStateobject
latestImageRegistryPollstring

The last time the CatalogSource image registry has been polled to ensure the image is up-to-date

messagestring

A human readable message indicating details about why the CatalogSource is in this condition.

reasonstring

Reason is the reason the CatalogSource was transitioned to its current state.

registryServiceobject

.status.conditions

Description
Represents the state of a CatalogSource. Note that Message and Reason represent the original status information, which may be migrated to be conditions based in the future. Any new features introduced will use conditions.
Type
array

.status.conditions[]

Description
Condition contains details for one aspect of the current state of this API Resource. --- This struct is intended for direct use as an array at the field path .status.conditions. For example, type FooStatus struct{ // Represents the observations of a foo's current state. // Known .status.conditions.type are: "Available", "Progressing", and "Degraded" // +patchMergeKey=type // +patchStrategy=merge // +listType=map // +listMapKey=type Conditions []metav1.Condition `json:"conditions,omitempty" patchStrategy:"merge" patchMergeKey:"type" protobuf:"bytes,1,rep,name=conditions"` // other fields }
Type
object
Required
lastTransitionTimemessagereasonstatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This may be an empty string.

observedGenerationinteger

observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

reasonstring

reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase. --- Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important. The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)

.status.configMapReference

Type
object
Required
namenamespace
PropertyTypeDescription
lastUpdateTimestring
namestring
namespacestring
resourceVersionstring
uidstring

UID is a type that holds unique ID values, including UUIDs. Because we don't ONLY use UUIDs, this is an alias to string. Being a type captures intent and helps make sure that UIDs and names do not get conflated.

.status.connectionState

Type
object
Required
lastObservedState
PropertyTypeDescription
addressstring
lastConnectstring
lastObservedStatestring

.status.registryService

Type
object
PropertyTypeDescription
createdAtstring
portstring
protocolstring
serviceNamestring
serviceNamespacestring

API Endpoints

The following API endpoints are available:

  • /apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources
    • DELETE: delete collection of CatalogSource
    • GET: list objects of kind CatalogSource
    • POST: create a new CatalogSource
  • /apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources/{name}
    • DELETE: delete the specified CatalogSource
    • GET: read the specified CatalogSource
    • PATCH: partially update the specified CatalogSource
    • PUT: replace the specified CatalogSource
  • /apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources/{name}/status
    • GET: read status of the specified CatalogSource
    • PATCH: partially update status of the specified CatalogSource
    • PUT: replace status of the specified CatalogSource

/apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources

HTTP method
DELETE
Description
delete collection of CatalogSource
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind CatalogSource
HTTP responses
HTTP codeResponse body
200 - OKCatalogSourceList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyCatalogSource schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
201 - CreatedCatalogSource schema
202 - AcceptedCatalogSource schema
401 - UnauthorizedEmpty

/apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources/{name}

HTTP method
DELETE
Description
delete the specified CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified CatalogSource
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyCatalogSource schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
201 - CreatedCatalogSource schema
401 - UnauthorizedEmpty

/apis/operators.coreos.com/v1alpha1/namespaces/{namespace}/catalogsources/{name}/status

HTTP method
GET
Description
read status of the specified CatalogSource
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified CatalogSource
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyCatalogSource schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKCatalogSource schema
201 - CreatedCatalogSource schema
401 - UnauthorizedEmpty